package ch10.hashtable;

public class Htable implements HashTable<Student>{
	final int SIZE = 10; // Hash table will have size 10
	public Student[] list = new Student[SIZE]; // Hashtable of students

	public void add(int key, Student s) { 
		//////////////////////////////////////
		///// STEP 2.  Add Linear Probing in the event of a collision
		//////////////////////////////////////
		int location = hash(key); // Apply the hash function to get the location
		list[location] = s; // Set the value into the hashtable
	}
	
	public Student find(int key) {
		/////////////////////////////////////
		////// STEP 3. Fix find to accomodate linear probing
		////////////////////////////////////
		int location = hash(key); // apply the hash function
		return list[location]; // return the found result 
	}

	public Student remove(int key) {
		/////////////////////////////////////
		////// STEP 4. Compensate for Linear Probing
		//////////////////////////////////////

		int location = hash(key); // apply the hash function
		Student s = list[location]; // get the object at the location
		list[location] = null; // clear the object out of the hash table

		/////////////////////////////////////
		////// STEP 5. Compensate for infinite looping
		/////////////////////////////////////


		////////////////////////////////////
		///// STEP 6. Throw HashNotFound exception if key is not there
		////////////////////////////////////
		return s;
	}	
	public int hash(int key) {
		return key%SIZE; // simple hash function to get the last digit
	}
}
